.\"	$NetBSD: pstat.8,v 1.38 2009/10/14 22:59:11 joerg Exp $
.\"
.\" Copyright (c) 1980, 1991, 1993, 1994
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     from: @(#)pstat.8	8.5 (Berkeley) 5/13/94
.\"
.Dd December 5, 2009
.Dt PSTAT 8
.Os
.Sh NAME
.Nm pstat
.Nd display system data structures
.Sh SYNOPSIS
.Nm
.Oo
.Fl T | Fl f | Fl s |
.Fl t | Fl v
.Oc
.Op Fl ghkmn
.Op Fl M Ar core
.Op Fl N Ar system
.Sh DESCRIPTION
.Nm
displays open file entry, swap space utilization,
terminal state, and vnode data structures.
If
.Ar corefile
is given, the information is sought there, otherwise
in
.Pa /dev/kmem .
The required namelist is taken from
.Pa /netbsd
unless
.Ar system
is specified.
.Pp
The following options are available:
.Bl -tag -width Ds
.It Fl T
Prints the number of used and free slots for open files, used vnodes, and swap
space.
This option is useful for checking to see how large system tables
become if the system is under heavy load.
.It Fl f
Print the open file table with these headings:
.Bl -tag -width indent
.It LOC
The core location of this table entry.
.It TYPE
The type of object the file table entry points to.
.It FLG
Miscellaneous state variables encoded thus:
.Pp
.Bl -tag -width indent -compact
.It R
open for reading
.It W
open for writing
.It A
open for appending
.It S
shared lock present
.It X
exclusive lock present
.It I
signal pgrp when data ready
.El
.It CNT
Number of processes that know this open file.
.It MSG
Number of messages outstanding for this file.
.It DATA
The location of the vnode table entry or socket structure for this file.
.It USE
Number of active users of this open file.
.It IFLG
Value of internal flags.
.It OFFSET
The file offset (see
.Xr lseek 2 ) .
.El
.It Fl g
The
.Fl g
option uses (1024 * 1024 * 1024) byte blocks instead of the default 512 byte.
.It Fl h
Use
.Xr humanize_number 3
to display (swap) sizes.
.It Fl k
Use 1K-byte blocks.
.It Fl m
The
.Fl m
option uses (1024 * 1024) byte blocks instead of the default 512 byte.
.It Fl n
Print devices by major/minor number rather than by name.
.It Fl s
Print information about swap space usage on all the
swap areas compiled into the kernel.
The first column is the device name of the partition.
The next column is the total space available in the partition.
The
.Ar Used
column indicates the total blocks used so far;  the
.Ar Available
column indicates how much space is remaining on each partition.
The
.Ar Capacity
reports the percentage of space used.
.Pp
If more than one partition is configured into the system, totals for all
of the statistics will be reported in the final line of the report.
.It Fl t
Print table for terminals
with these headings:
.Bl -tag -width indent
.It LINE
Physical device name.
.It RAW
Number of characters in raw input queue.
.It CAN
Number of characters in canonicalized input queue.
.It OUT
Number of characters in output queue.
.It HWT
High water mark for output.
.It LWT
Low water mark for output.
.It COL
Calculated column position of terminal.
.It STATE
Miscellaneous state variables encoded thus:
.Pp
.Bl -tag -width indent -compact
.It T
delay timeout in progress
.\" .It W
.\" waiting for open to complete
.It O
open
.It F
outq has been flushed during DMA
.It C
carrier is on
.It B
busy doing output
.It A
process is awaiting output
.It X
open for exclusive use
.It S
output stopped
.It K
further input blocked
.It Y
tty in async I/O mode
.It D
state for lowercase
.Ql \e
work
.It E
within a
.Ql \e.../
for PRTRUB
.It L
next character is literal
.It P
retyping suspended input
.Pq PENDIN
.It N
counting tab width, ignore FLUSHO
.It \&\*[Gt]
tty used for dialout
.El
.It SESS
Session for which this is controlling terminal.
.It PGID
Current foreground process group associated with this terminal.
.It DISC
Line discipline;
.Ql term
for
TTYDISC (see
.Xr termios 4 ) ,
.Ql tab
for TABLDISC (see
.Xr tb 4 ) ,
.Ql slip
for SLIPDISC (see
.Xr sl 4 ) ,
.Ql ppp
for PPPDISC (see
.Xr ppp 4 ) ,
.Ql strip
for STRIPDISC (see
.Xr strip 4 ) ,
.Ql hdlc
for HDLCDISC.
.El
.It Fl v
Print the active vnodes.
Each group of vnodes corresponding to a particular filesystem is preceded
by a two line header.
The first line consists of the following:
.Pp
.No *** MOUNT Em fstype from Li on Em on fsflags
.Pp
where
.Em fstype
is one of
.Em adosfs , afs , cd9660 , fdesc ,
.Em ffs , ext2fs , kernfs , lfs , lofs ,
.Em mfs , msdos , nfs , null ,
.Em procfs , umap , union ;
.Em from
is the filesystem mounted from;
.Em on
is the directory
the filesystem is mounted on; and
.Em fsflags
is a list
of optional flags applied to the mount (see
.Xr mount 8 ) .
The second line is a header for the individual fields,
the first part of which are fixed, and the second part are filesystem
type specific.
The headers common to all vnodes are:
.Bl -tag -width indent
.It ADDR
Location of this vnode.
.It TYP
File type.
.It VFLAG
A list of letters representing vnode flags:
.Pp
.Bl -tag -width indent -compact
.It R
VROOT root of its file system.
.It T
VTEXT pure text prototype.
.It S
VSYSTEM vnode being used by kernel.
.It I
VISTTY vnode is a tty.
.It E
VEXECMAP vnode has PROT_EXEC mappings.
.It L
VXLOCK locked to change underlying type.
.It W
VXWANT process is waiting for vnode.
.It B
VBWAIT waiting for output to complete.
.It A
VALIASED vnode has an alias.
.It D
VDIROP lfs vnode involved in directory op.
.It Y
VLAYER vnode is on layer filesystem.
.It O
VONWORKLST vnode is on syncer work-list.
.El
.Pp
.It USE
The number of references to this vnode.
.It HOLD
The number of I/O buffers held by this vnode.
.It TAG
The type of underlying data.
.It NPAGE
The number of pages in this vnode.
.It FILEID
The vnode fileid.
In the case of
.Em ffs
or
.Em ext2fs
this is the inode number.
.It IFLAG
Miscellaneous filesystem specific state variables encoded thus:
.Bl -tag -width indent
.It "For ffs, lfs or ext2fs:"
.Bl -tag -width indent -compact
.It A
access time must be corrected
.It C
changed time must be corrected
.It U
update time
.Pq Xr fs 5
must be corrected
.It M
contains modifications
.It a
has been accessed
.It R
has a rename in progress
.It S
shared lock applied
.It E
exclusive lock applied
.It c
is being cleaned (LFS)
.It D
directory operation in progress (LFS)
.It s
blocks to be freed in free count
.El
.It "For nfs:"
.Bl -tag -width indent -compact
.It W
waiting for I/O buffer flush to complete
.It P
I/O buffers being flushed
.It M
locally modified data exists
.It E
an earlier write failed
.It A
special file accessed
.It U
special file updated
.It C
special file times changed
.El
.El
.It SIZ/RDEV
Number of bytes in an ordinary file, or
major and minor device of special file.
.El
.El
.Sh ENVIRONMENT
.Bl -tag -width BLOCKSIZE
.It Ev BLOCKSIZE
If the environment variable
.Ev BLOCKSIZE
is set, and the
.Fl k
option is not specified, the block counts will be displayed in units of that
size block.
.El
.Sh FILES
.Bl -tag -width /dev/kmemxxx -compact
.It Pa /netbsd
namelist
.It Pa /dev/kmem
default source of tables
.El
.Sh SEE ALSO
.Xr ps 1 ,
.Xr systat 1 ,
.Xr vmstat 1 ,
.Xr stat 2 ,
.Xr fs 5 ,
.Xr iostat 8
.Rs
.%T Tn UNIX Implementation
.%A K. Thompson
.Re
.Sh HISTORY
The
.Nm
command appeared in
.Bx 4.0 .
.Sh BUGS
Swap statistics are reported for all swap partitions compiled into the kernel,
regardless of whether those partitions are being used.
.Pp
Does not understand NFS swap servers.
